package mca.blocks;

import com.google.common.base.Optional;
import mca.core.MCA;
import mca.entity.EntityVillagerMCA;
import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import java.util.Random;


import java.util.Random;

public class BlockVillagerSpawner extends Block {

    public BlockVillagerSpawner() {
        super(Material.field_151573_f);
        func_149675_a(true);
        func_149722_s();
    }

    @Override
    public void func_180650_b(World world, BlockPos pos, IBlockState state, Random random) {
        super.func_180650_b(world, pos, state, random);

        int nearbyVillagers = world.func_72872_a(EntityVillagerMCA.class, new AxisAlignedBB(pos).func_72321_a(32D, 32D, 32D)).size();
        if (nearbyVillagers < MCA.getConfig().villagerSpawnerCap) {
            int yMod = 0;

            // Start from the current point possible and count up until air is hit. This allows the spawner to
            // be placed anywhere below ground and still spawn a villager on a top level.
            while (pos.func_177956_o() + yMod < 256) {
                BlockPos current = pos.func_177982_a(0, yMod, 0);
                BlockPos above = pos.func_177982_a(0, yMod + 1, 0);

                if (world.func_175623_d(current) && world.func_175623_d(above)) {
                    EntityVillagerMCA villager = new EntityVillagerMCA(world, Optional.absent(), Optional.absent());
                    villager.func_70107_b(current.func_177958_n(), current.func_177956_o(), current.func_177952_p());
                    world.func_72838_d(villager);
                    break;
                }

                yMod++;
            }
        }

        world.func_175684_a(pos, this, MCA.getConfig().villagerSpawnerRateMinutes * 72000);
    }
}
