package mca.client.gui;

import mca.api.API;
import mca.client.gui.component.GuiButtonEx;
import mca.core.Constants;
import mca.core.MCA;
import mca.core.forge.NetMCA;
import mca.entity.EntityVillagerMCA;
import mca.entity.data.ParentData;
import mca.entity.data.PlayerHistory;
import mca.enums.EnumMarriageState;
import mca.enums.EnumMoveState;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import org.lwjgl.input.Keyboard;
import org.lwjgl.input.Mouse;
import org.lwjgl.opengl.GL11;
import java.io.IOException;
import java.util.Optional;


import java.io.IOException;
import java.util.Optional;

@SideOnly(Side.CLIENT)
public class GuiInteract extends GuiScreen {
    private static final ResourceLocation ICON_TEXTURES = new ResourceLocation("mca:textures/gui.png");
    private static boolean displaySuccessChance;
    private final EntityVillagerMCA villager;
    private final EntityPlayer player;

    private boolean inGiftMode;

    private int timeSinceLastClick;

    private int marriedIconU = 0;
    private int engagedIconU = 64;
    private int notMarriedIconU = 16;
    private int parentsIconU = 32;
    private int giftIconU = 48;
    private int redHeartIconU = 80;
    private int blackHeartIconU = 96;
    private int goldHeartIconU = 112;

    private int mouseX;
    private int mouseY;

    // Tracks which page we're on in the GUI for sending button events
    private String activeKey;

    public GuiInteract(EntityVillagerMCA villager, EntityPlayer player) {
        super();
        this.villager = villager;
        this.player = player;
        this.activeKey = "main";
    }

    @Override
    public void func_73866_w_() {
        drawMainButtonMenu();
    }

    @Override
    public void func_146281_b() {
    }

    @Override
    public boolean func_73868_f() {
        return false;
    }

    @Override
    public void func_73876_c() {
        if (timeSinceLastClick < 100) {
            timeSinceLastClick++;
        }
    }

    @Override
    public void func_73863_a(int i, int j, float f) {
        super.func_73863_a(i, j, f);
        drawIcons();
        drawTextPopups();

        mouseX = Mouse.getEventX() * field_146294_l / field_146297_k.field_71443_c;
        mouseY = field_146295_m - Mouse.getEventY() * field_146295_m / field_146297_k.field_71440_d - 1;
    }

    @Override
    public void func_146274_d() throws IOException {
        super.func_146274_d();

        if (Mouse.getEventDWheel() < 0) {
            player.field_71071_by.field_70461_c = player.field_71071_by.field_70461_c == 8 ? 0 : player.field_71071_by.field_70461_c + 1;
        } else if (Mouse.getEventDWheel() > 0) {
            player.field_71071_by.field_70461_c = player.field_71071_by.field_70461_c == 0 ? 8 : player.field_71071_by.field_70461_c - 1;
        }
    }

    @Override
    protected void func_73864_a(int posX, int posY, int button) throws IOException {
        super.func_73864_a(posX, posY, button);

        // Right mouse button
        if (inGiftMode && button == 1) NetMCA.INSTANCE.sendToServer(new NetMCA.ButtonAction(activeKey, "gui.button.gift", villager.func_110124_au()));
    }

    @Override
    protected void func_73869_a(char keyChar, int keyCode) {
        // Hotkey to leave gift mode
        if (keyCode == Keyboard.KEY_ESCAPE) {
            if (inGiftMode) {
                inGiftMode = false;
                enableAllButtons();
            } else {
                this.field_146297_k.func_147108_a(null);
            }
        } else if (keyCode == Keyboard.KEY_LCONTROL) {
            displaySuccessChance = !displaySuccessChance;
        } else {
            try {
                int intInput = Integer.parseInt(String.valueOf(keyChar));

                if (intInput > 0) {
                    player.field_71071_by.field_70461_c = intInput - 1;
                }
            } catch (NumberFormatException ignored) {
                // When a non numeric character is entered.
            }
        }
    }

    private void drawIcons() {
        PlayerHistory history = villager.getPlayerHistoryFor(player.func_110124_au());
        EnumMarriageState marriageState = EnumMarriageState.byId(villager.get(EntityVillagerMCA.MARRIAGE_STATE));
        int marriageIconU =
                marriageState == EnumMarriageState.MARRIED ? marriedIconU :
                        marriageState == EnumMarriageState.ENGAGED ? engagedIconU :
                                notMarriedIconU;
        int heartIconU =
                history.getHearts() < 0 ? blackHeartIconU :
                        history.getHearts() >= 100 ? goldHeartIconU :
                                redHeartIconU;

        GL11.glPushMatrix();
        {
            GL11.glColor3f(255.0F, 255.0F, 255.0F);
            GL11.glScalef(2.0F, 2.0F, 2.0F);

            this.field_146297_k.func_110434_K().func_110577_a(ICON_TEXTURES);
            this.func_73729_b(5, 15, heartIconU, 0, 16, 16);
            this.func_73729_b(5, 30, marriageIconU, 0, 16, 16);

            if (canDrawParentsIcon()) this.func_73729_b(5, 45, parentsIconU, 0, 16, 16);

            if (canDrawGiftIcon()) this.func_73729_b(5, 60, giftIconU, 0, 16, 16);
        }
        GL11.glPopMatrix();
    }

    private void drawTextPopups() {
        EnumMarriageState marriageState = EnumMarriageState.byId(villager.get(EntityVillagerMCA.MARRIAGE_STATE));
        String marriageInfo;

        if (hoveringOverHeartsIcon()) {
            int hearts = villager.getPlayerHistoryFor(player.func_110124_au()).getHearts();
            this.func_146279_a(hearts + " hearts", 35, 55);
        }

        if (hoveringOverMarriageIcon()) {
            String spouseName = villager.get(EntityVillagerMCA.SPOUSE_NAME);
            if (marriageState == EnumMarriageState.MARRIED) marriageInfo = MCA.getLocalizer().localize("gui.interact.label.married", spouseName);
            else if (marriageState == EnumMarriageState.ENGAGED) marriageInfo = MCA.getLocalizer().localize("gui.interact.label.engaged", spouseName);
            else marriageInfo = MCA.getLocalizer().localize("gui.interact.label.notmarried");

            this.func_146279_a(marriageInfo, 35, 85);
        }
        if (canDrawParentsIcon() && hoveringOverParentsIcon()) {
            ParentData data = ParentData.fromNBT(villager.get(EntityVillagerMCA.PARENTS));
            this.func_146279_a(MCA.getLocalizer().localize("gui.interact.label.parents", data.getParent1Name(), data.getParent2Name()), 35, 115);
        }

        if (canDrawGiftIcon() && hoveringOverGiftIcon()) this.func_146279_a(MCA.getLocalizer().localize("gui.interact.label.gift"), 35, 145);
    }

    private boolean hoveringOverHeartsIcon() {
        return mouseX <= 32 && mouseX >= 16 && mouseY >= 32 && mouseY <= 48;
    }

    private boolean hoveringOverMarriageIcon() {
        return mouseX <= 32 && mouseX >= 16 && mouseY >= 66 && mouseY <= 81;
    }

    private boolean hoveringOverParentsIcon() {
        return mouseX <= 32 && mouseX >= 16 && mouseY >= 100 && mouseY <= 115;
    }

    private boolean hoveringOverGiftIcon() {
        return mouseX <= 32 && mouseX >= 16 && mouseY >= 124 && mouseY <= 148;
    }

    private boolean canDrawParentsIcon() {
        ParentData data = ParentData.fromNBT(villager.get(EntityVillagerMCA.PARENTS));
        return !data.getParent1UUID().equals(Constants.ZERO_UUID) &&
                !data.getParent2UUID().equals(Constants.ZERO_UUID);
    }

    private boolean canDrawGiftIcon() {
        return villager.getPlayerHistoryFor(player.func_110124_au()).isGiftPresent();
    }

    protected void func_146284_a(GuiButton button) {
        GuiButtonEx btn = (GuiButtonEx) button;
        String id = btn.getApiButton().getIdentifier();

        if (timeSinceLastClick <= 2) {
            return; /* Prevents click-throughs on Mojang's button system */
        }
        timeSinceLastClick = 0;

        /* Progression to different GUIs */
        if (id.equals("gui.button.interact")) {
            activeKey = "interact";
            drawInteractButtonMenu();
            return;
        } else if (id.equals("gui.button.work")) {
            activeKey = "work";
            drawWorkButtonMenu();
            return;
        } else if (id.equals("gui.button.backarrow")) {
            drawMainButtonMenu();
            activeKey = "main";
            return;
        } else if (id.equals("gui.button.location")) {
            activeKey = "location";
            drawLocationButtonMenu();
            return;
        }

        /* Anything that should notify the server is handled here */
        else if (btn.getApiButton().isNotifyServer()) {
            NetMCA.INSTANCE.sendToServer(new NetMCA.ButtonAction(activeKey, id, villager.func_110124_au()));
        } else if (id.equals("gui.button.gift")) {
            this.inGiftMode = true;
            disableAllButtons();
            return;
        }

        this.field_146297_k.func_147108_a(null);
    }

    private void drawMainButtonMenu() {
        field_146292_n.clear();
        API.addButtons("main", villager, player, this);

        EnumMoveState moveState = EnumMoveState.byId(villager.get(EntityVillagerMCA.MOVE_STATE));
        if (moveState == EnumMoveState.FOLLOW) disableButton("gui.button.follow");
        else if (moveState == EnumMoveState.STAY) disableButton("gui.button.stay");
        else if (moveState == EnumMoveState.MOVE) disableButton("gui.button.move");
    }

    private void drawInteractButtonMenu() {
        field_146292_n.clear();
        API.addButtons("interact", villager, player, this);
    }

    private void drawWorkButtonMenu() {
        field_146292_n.clear();
        API.addButtons("work", villager, player, this);
    }

    private void drawLocationButtonMenu() {
        field_146292_n.clear();
        API.addButtons("location", villager, player, this);
    }

    private void disableButton(String id) {
        Optional<GuiButtonEx> b = API.getButton(id, this);

        b.ifPresent(guiButtonEx -> guiButtonEx.field_146124_l = false);
    }

    private void enableAllButtons() {
        field_146292_n.forEach((b) -> b.field_146124_l = true);
    }

    private void disableAllButtons() {
        field_146292_n.forEach((b) -> b.field_146124_l = false);
    }
}
