package mca.client.gui;

import mca.core.MCA;
import mca.core.forge.NetMCA;
import mca.entity.EntityVillagerMCA;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.client.gui.inventory.GuiInventory;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.UUID;


import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.UUID;

@SideOnly(Side.CLIENT)
public class GuiStaffOfLife extends GuiScreen {
    private Map<String, NBTTagCompound> villagerData;
    private GuiButton reviveButton;
    private GuiButton nameButton;
    private GuiButton backButton;
    private GuiButton nextButton;
    private GuiButton closeButton;
    private EntityVillagerMCA dummy;
    private EntityPlayer player;

    // selection fields
    private int index = 0;
    private List<String> keys = new ArrayList<>();

    public GuiStaffOfLife(EntityPlayer player) {
        super();
        this.player = player;
    }

    @Override
    public void func_73866_w_() {
        NetMCA.INSTANCE.sendToServer(new NetMCA.SavedVillagersRequest());

        field_146292_n.clear();
        field_146292_n.add(backButton = new GuiButton(1, field_146294_l / 2 - 123, field_146295_m / 2 + 65, 20, 20, "<<"));
        field_146292_n.add(nextButton = new GuiButton(2, field_146294_l / 2 + 103, field_146295_m / 2 + 65, 20, 20, ">>"));
        field_146292_n.add(nameButton = new GuiButton(3, field_146294_l / 2 - 100, field_146295_m / 2 + 65, 200, 20, ""));
        field_146292_n.add(reviveButton = new GuiButton(4, field_146294_l / 2 - 100, field_146295_m / 2 + 90, 60, 20, MCA.getLocalizer().localize("gui.button.revive")));
        field_146292_n.add(closeButton = new GuiButton(5, field_146294_l / 2 + 40, field_146295_m / 2 + 90, 60, 20, MCA.getLocalizer().localize("gui.button.exit")));
    }

    @Override
    public boolean func_73868_f() {
        return false;
    }

    @Override
    protected void func_146284_a(GuiButton guibutton) {
        if (guibutton == reviveButton) {
            NetMCA.INSTANCE.sendToServer(new NetMCA.ReviveVillager(UUID.fromString(keys.get(index))));
            field_146297_k.func_147108_a(null);
        } else if (guibutton == backButton) selectData(index - 1);
        else if (guibutton == nextButton) selectData(index + 1);
        else if (guibutton == closeButton) field_146297_k.func_147108_a(null);
    }

    @Override
    public void func_73863_a(int sizeX, int sizeY, float offset) {
        func_146276_q_();
        drawDummy();
        func_73732_a(field_146289_q, MCA.getLocalizer().localize("gui.title.staffoflife"), field_146294_l / 2, field_146295_m / 2 - 110, 0xffffff);
        super.func_73863_a(sizeX, sizeY, offset);
    }

    public void setVillagerData(Map<String, NBTTagCompound> data) {
        villagerData = data;

        if (data.size() > 0) {
            dummy = new EntityVillagerMCA(player.field_70170_p);
            keys.addAll(data.keySet());
            selectData(0);
        } else {
            nameButton.field_146126_j = "No villagers found.";
            backButton.field_146124_l = false;
            nextButton.field_146124_l = false;
            nameButton.field_146124_l = false;
            reviveButton.field_146124_l = false;
        }
    }

    private void updateDummy(NBTTagCompound nbt) {
        dummy.func_70037_a(nbt);
        dummy.func_70606_j(20.0F);
    }

    private void selectData(int i) {
        if (i < 0) i = keys.size() - 1;
        else if (i > keys.size() - 1) i = 0;

        index = i;
        updateDummy(villagerData.get(keys.get(index)));
        nameButton.field_146126_j = dummy.func_145748_c_().func_150260_c();
    }

    private void drawDummy() {
        int posX = field_146294_l / 2;
        int posY = field_146295_m / 2 + 45;

        if (dummy != null) GuiInventory.func_147046_a(posX, posY, 60, 0, 0, dummy);
    }
}
