package mca.client.gui;

import mca.api.API;
import mca.api.types.APIButton;
import mca.client.gui.component.GuiButtonEx;
import mca.core.MCA;
import mca.core.forge.NetMCA;
import mca.entity.EntityVillagerMCA;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.client.gui.GuiTextField;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import org.lwjgl.input.Keyboard;
import java.awt.Toolkit;
import java.awt.datatransfer.StringSelection;
import java.io.IOException;


import java.awt.*;
import java.awt.datatransfer.StringSelection;
import java.io.IOException;

@SideOnly(Side.CLIENT)
public class GuiVillagerEditor extends GuiScreen {
    private final EntityVillagerMCA villager;
    private final EntityPlayer player;

    private GuiTextField nameTextField;
    private GuiTextField professionTextField;
    private GuiTextField textureTextField;

    public GuiVillagerEditor(EntityVillagerMCA EntityHuman, EntityPlayer player) {
        super();
        this.player = player;
        villager = EntityHuman;
    }

    @Override
    public void func_73876_c() {
        super.func_73876_c();
        nameTextField.func_146178_a();
        professionTextField.func_146178_a();
        textureTextField.func_146178_a();
    }

    @Override
    public void func_73866_w_() {
        Keyboard.enableRepeatEvents(true);
        drawEditorGui();

        nameTextField = new GuiTextField(1, field_146289_q, field_146294_l / 2 - 205, field_146295_m / 2 - 95, 150, 20);
        nameTextField.func_146203_f(32);
        nameTextField.func_146180_a(villager.get(EntityVillagerMCA.VILLAGER_NAME));
        professionTextField = new GuiTextField(2, field_146289_q, field_146294_l / 2 - 190, field_146295_m / 2 + 10, 250, 20);
        professionTextField.func_146203_f(64);
        professionTextField.func_146180_a(villager.getVanillaCareer().getName());
        textureTextField = new GuiTextField(3, field_146289_q, field_146294_l / 2 - 190, field_146295_m / 2 - 15, 250, 20);
        textureTextField.func_146203_f(128);
        textureTextField.func_146180_a(villager.get(EntityVillagerMCA.TEXTURE));
    }

    @Override
    public void func_146281_b() {
        Keyboard.enableRepeatEvents(false);
    }

    @Override
    protected void func_146284_a(GuiButton guiButton) {
        APIButton btn = ((GuiButtonEx) guiButton).getApiButton();
        if (btn.isNotifyServer()) {
            NetMCA.INSTANCE.sendToServer(new NetMCA.ButtonAction("editor", btn.getIdentifier(), villager.func_110124_au()));
        } else if (btn.getIdentifier().equals("gui.button.done")) {
            field_146297_k.func_147108_a(null);
        } else if (btn.getIdentifier().equals("gui.button.copyuuid")) {
            Toolkit.getDefaultToolkit().getSystemClipboard().setContents(new StringSelection(villager.func_110124_au().toString()), null);
            Minecraft.func_71410_x().field_71439_g.func_71165_d("Villager UUID copied to clipboard.");
        } else if (btn.getIdentifier().equals("gui.button.profession.set")) {
            String profession = professionTextField.func_146179_b();
            NetMCA.INSTANCE.sendToServer(new NetMCA.SetProfession(villager.func_110124_au(), profession));
            new java.util.Timer().schedule(new java.util.TimerTask() {
                        @Override
                        public void run() {
                            NetMCA.INSTANCE.sendToServer(new NetMCA.CareerRequest(villager.func_110124_au()));
                        }
                    },500
            );
        } else if (btn.getIdentifier().contains("gui.button.texture")) {
            String texture = btn.getIdentifier().endsWith(".set") ? textureTextField.func_146179_b() : API.getRandomSkin(villager);
            NetMCA.INSTANCE.sendToServer(new NetMCA.SetTexture(villager.func_110124_au(), texture));
            textureTextField.func_146180_a(texture);
        }
    }

    @Override
    protected void func_73869_a(char c, int i) {
        if (i == Keyboard.KEY_ESCAPE) {
            Minecraft.func_71410_x().func_147108_a(null);
        } else {
            if (nameTextField.func_146201_a(c, i)) {
                String text = nameTextField.func_146179_b().trim();
                NetMCA.INSTANCE.sendToServer(new NetMCA.SetName(text, villager.func_110124_au()));
            }
            textureTextField.func_146201_a(c, i);
            professionTextField.func_146201_a(c, i);
            drawEditorGui();
        }
    }

    @Override
    protected void func_73864_a(int clickX, int clickY, int clicked) throws IOException {
        super.func_73864_a(clickX, clickY, clicked);
        nameTextField.func_146192_a(clickX, clickY, clicked);
        professionTextField.func_146192_a(clickX, clickY, clicked);
        textureTextField.func_146192_a(clickX, clickY, clicked);
    }

    @Override
    public boolean func_73868_f() {
        return false;
    }

    private void drawEditorGui() {
        field_146292_n.clear();
        API.addButtons("editor", villager, player, this);
    }

    @Override
    public void func_73863_a(int sizeX, int sizeY, float offset) {
        func_73733_a(0, 0, field_146294_l, field_146295_m, -1072689136, -804253680);
        func_73731_b(field_146289_q, "Name:", field_146294_l / 2 - 205, field_146295_m / 2 - 110, 0xffffff);
        func_73732_a(field_146289_q, MCA.getLocalizer().localize("gui.title.editor"), field_146294_l / 2, field_146295_m / 2 - 110, 0xffffff);
        nameTextField.func_146194_f();
        professionTextField.func_146194_f();
        textureTextField.func_146194_f();
        super.func_73863_a(sizeX, sizeY, offset);
    }
}
