package mca.client.gui;

import lombok.NonNull;
import mca.core.forge.NetMCA;
import net.minecraft.nbt.NBTTagCompound;
import org.apache.commons.lang3.StringUtils;
import java.util.List;
import mca.core.MCA;
import mca.entity.EntityVillagerMCA;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.GuiScreen;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;


import mca.core.MCA;
import mca.entity.EntityVillagerMCA;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.GuiScreen;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import java.util.List;

import static mca.entity.EntityVillagerMCA.*;

@SideOnly(Side.CLIENT)
public class GuiWhistle extends GuiScreen {
    private EntityVillagerMCA dummyHuman;
    private List<NBTTagCompound> villagerDataList;

    private GuiButton selectionLeftButton;
    private GuiButton selectionRightButton;
    private GuiButton villagerNameButton;
    private GuiButton callButton;
    private GuiButton exitButton;
    private int loadingAnimationTicks;
    private int selectedIndex;

    @Override
    public void func_73876_c() {
        super.func_73876_c();

        if (loadingAnimationTicks != -1) {
            loadingAnimationTicks++;
        }

        if (loadingAnimationTicks >= 20) {
            loadingAnimationTicks = 0;
        }
    }

    @Override
    public void func_73866_w_() {
        field_146292_n.clear();
        field_146292_n.add(selectionLeftButton = new GuiButton(1, field_146294_l / 2 - 123, field_146295_m / 2 + 65, 20, 20, "<<"));
        field_146292_n.add(selectionRightButton = new GuiButton(2, field_146294_l / 2 + 103, field_146295_m / 2 + 65, 20, 20, ">>"));
        field_146292_n.add(villagerNameButton = new GuiButton(3, field_146294_l / 2 - 100, field_146295_m / 2 + 65, 200, 20, ""));
        field_146292_n.add(callButton = new GuiButton(4, field_146294_l / 2 - 100, field_146295_m / 2 + 90, 60, 20, MCA.getLocalizer().localize("gui.button.call")));
        field_146292_n.add(exitButton = new GuiButton(6, field_146294_l / 2 + 40, field_146295_m / 2 + 90, 60, 20, MCA.getLocalizer().localize("gui.button.exit")));
        NetMCA.INSTANCE.sendToServer(new NetMCA.GetFamily());
    }

    @Override
    public boolean func_73868_f() {
        return false;
    }

    @Override
    protected void func_146284_a(GuiButton guibutton) {
        if (guibutton == exitButton) {
            Minecraft.func_71410_x().func_147108_a(null);
        }

        if (villagerDataList != null && villagerDataList.size() > 0) {
            NBTTagCompound data = villagerDataList.get(selectedIndex - 1);

            if (guibutton == selectionLeftButton) {
                if (selectedIndex == 1) {
                    selectedIndex = villagerDataList.size();
                }

                else {
                    selectedIndex--;
                }
            }

            else if (guibutton == selectionRightButton) {
                if (selectedIndex == villagerDataList.size()) {
                    selectedIndex = 1;
                }

                else {
                    selectedIndex++;
                }
            }

            else if (guibutton == callButton) {
                NetMCA.INSTANCE.sendToServer(new NetMCA.CallToPlayer(data.func_186857_a("uuid")));
                Minecraft.func_71410_x().func_147108_a(null);
            }

            villagerNameButton.field_146126_j = data.func_74779_i("name");
            updateDummyVillagerWithData(data);
        }
    }

    @Override
    public void func_73863_a(int sizeX, int sizeY, float offset) {
        func_146276_q_();
        func_73732_a(field_146289_q, MCA.getLocalizer().localize("gui.title.whistle"), field_146294_l / 2, field_146295_m / 2 - 110, 0xffffff);

        if (loadingAnimationTicks != -1) {
            func_73731_b(field_146289_q, "Loading" + StringUtils.repeat(".", loadingAnimationTicks % 10), field_146294_l / 2 - 20, field_146295_m / 2 - 10, 0xffffff);
        }

        else {
            if (villagerDataList.size() == 0) {
                func_73732_a(field_146289_q, "No family members could be found in the area.", field_146294_l / 2, field_146295_m / 2 + 50, 0xffffff);
            }

            else {
                func_73732_a(field_146289_q, selectedIndex + " / " + villagerDataList.size(), field_146294_l / 2, field_146295_m / 2 + 50, 0xffffff);
            }
        }

        if (dummyHuman != null) {
            drawDummyVillager();
        }

        super.func_73863_a(sizeX, sizeY, offset);
    }

    private void drawDummyVillager() {
        final int posX = field_146294_l / 2;
        int posY = field_146295_m / 2 + 45;
        net.minecraft.client.gui.inventory.GuiInventory.func_147046_a(posX, posY, 75, 0, 0, dummyHuman);
    }

    public void setVillagerDataList(@NonNull List<NBTTagCompound> dataList) {
        this.villagerDataList = dataList;
        this.loadingAnimationTicks = -1;
        this.selectedIndex = 1;

        try {
            NBTTagCompound firstData = dataList.get(0);
            villagerNameButton.field_146126_j = firstData.func_74779_i("name");
            dummyHuman = new EntityVillagerMCA(Minecraft.func_71410_x().field_71441_e);
            updateDummyVillagerWithData(firstData);
        }

        catch (IndexOutOfBoundsException e) {
            callButton.field_146124_l = false;
        }
    }

    private void updateDummyVillagerWithData(NBTTagCompound nbt) {
        dummyHuman.set(VILLAGER_NAME, nbt.func_74779_i("name"));
        dummyHuman.set(TEXTURE, nbt.func_74779_i("texture"));
        dummyHuman.set(GIRTH, nbt.func_74760_g("girth"));
        dummyHuman.set(TALLNESS, nbt.func_74760_g("tallness"));
        dummyHuman.set(IS_INFECTED, nbt.func_74767_n("infected"));
        dummyHuman.set(AGE_STATE, nbt.func_74762_e("ageState"));
    }
}
