package mca.core.forge;

import mca.client.gui.*;
import mca.core.Constants;
import mca.core.MCA;
import mca.entity.EntityVillagerMCA;
import net.minecraft.client.gui.GuiScreenBook;
import net.minecraft.client.gui.inventory.GuiChest;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.ContainerChest;
import net.minecraft.world.World;
import net.minecraftforge.fml.common.network.IGuiHandler;

public class GuiHandler implements IGuiHandler {
    @Override
    public Object getServerGuiElement(int guiId, EntityPlayer player, World world, int entityId, int posY, int posZ) {
        switch (guiId) {
            case Constants.GUI_ID_INVENTORY:
                EntityVillagerMCA villager = (EntityVillagerMCA) world.func_73045_a(entityId);
                if (villager == null || villager.inventory == null) return null;
                return new ContainerChest(player.field_71071_by, villager.inventory, player);
            default:
                return null;
        }
    }

    @Override
    public Object getClientGuiElement(int guiId, EntityPlayer player, World world, int entityId, int unused1, int unused2) {
        switch (guiId) {
            case Constants.GUI_ID_INVENTORY:
                Entity entity = world.func_73045_a(entityId);
                if (entity == null) return null;
                return new GuiChest(player.field_71071_by, ((EntityVillagerMCA) entity).inventory);
            case Constants.GUI_ID_INTERACT:
                return new GuiInteract((EntityVillagerMCA) world.func_73045_a(entityId), player);
            case Constants.GUI_ID_NAMEBABY:
                return new GuiNameBaby(player, player.field_71071_by.func_70301_a(player.field_71071_by.field_70461_c));
            case Constants.GUI_ID_STAFFOFLIFE:
                return new GuiStaffOfLife(player);
            case Constants.GUI_ID_VILLAGEREDITOR:
                return new GuiVillagerEditor((EntityVillagerMCA) world.func_73045_a(entityId), player);
            case Constants.GUI_ID_GUIDEBOOK:
                return new GuiScreenBook(player, player.field_71071_by.func_70448_g(), false);
            case Constants.GUI_ID_WHISTLE:
                return new GuiWhistle();
            default:
                MCA.getLog().fatal("Failed to handle provided GUI ID on client: " + guiId);
                return null;
        }
    }
}
