package mca.entity.ai;

import mca.entity.EntityVillagerMCA;
import mca.enums.EnumChore;
import mca.util.Util;
import net.minecraft.block.BlockLeaves;
import net.minecraft.block.BlockLog;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.item.ItemAxe;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.BlockPos;
import java.util.ArrayList;
import java.util.List;


import java.util.ArrayList;
import java.util.List;

public class EntityAIChopping extends AbstractEntityAIChore {
    private int chopTicks;
    private BlockPos targetTree;

    public EntityAIChopping(EntityVillagerMCA entityIn) {
        super(entityIn);
        this.func_75248_a(1);
    }

    public boolean func_75250_a() {
        if (villager.func_110143_aJ() < villager.func_110138_aP()) {
            villager.stopChore();
        }
        return EnumChore.byId(villager.get(EntityVillagerMCA.ACTIVE_CHORE)) == EnumChore.CHOP;
    }

    public void func_75246_d() {
        if (!villager.inventory.contains(ItemAxe.class)) {
            villager.say(getAssigningPlayer(), "chore.chopping.noaxe");
            villager.stopChore();
        }
        if (targetTree == null) {
            List<BlockPos> nearbyLogs = Util.getNearbyBlocks(villager.func_190671_u_(), villager.field_70170_p, BlockLog.class, 10, 5);
            List<BlockPos> nearbyTrees = new ArrayList<>();

            // valid "trees" are logs on the ground with leaves around them
            nearbyLogs.stream()
                    .filter(log -> {
                        IBlockState down = villager.field_70170_p.func_180495_p(log.func_177977_b());
                        List<BlockPos> leaves = Util.getNearbyBlocks(log, villager.field_70170_p, BlockLeaves.class, 1, 5);
                        return leaves.size() > 0 && (down.func_177230_c() == Blocks.field_150349_c || down.func_177230_c() == Blocks.field_150346_d);
                    })
                    .forEach(nearbyTrees::add);
            targetTree = Util.getNearestPoint(villager.func_190671_u_(), nearbyTrees);
            return;
        }
        double distance = Math.sqrt(villager.func_174818_b(targetTree));
        if (distance >= 4.0D) villager.func_70661_as().func_75484_a(villager.func_70661_as().func_179680_a(targetTree), 0.5D);
        else {
            IBlockState state = villager.field_70170_p.func_180495_p(targetTree);
            if (state.func_177230_c() instanceof BlockLog) {
                BlockLog log = (BlockLog) state.func_177230_c();
                villager.func_184609_a(EnumHand.MAIN_HAND);
                chopTicks++;

                if (chopTicks >= 80) {
                    chopTicks = 0;
                    villager.inventory.func_174894_a(new ItemStack(log, 1));
                    villager.func_184586_b(EnumHand.MAIN_HAND).func_77972_a(2, villager);
                    if (villager.field_70170_p.field_73012_v.nextFloat() >= 0.90) destroyTree(targetTree);
                }
            } else targetTree = null;
        }
    }

    private void destroyTree(BlockPos origin) {
        BlockPos pos = origin;
        while (villager.field_70170_p.func_180495_p(pos).func_177230_c() instanceof BlockLog) {
            villager.field_70170_p.func_175698_g(pos);
            pos = pos.func_177982_a(0, 1, 0);
        }
    }
}
