package mca.entity.ai;

import mca.entity.EntityVillagerMCA;
import mca.enums.EnumChore;
import mca.util.Util;
import net.minecraft.block.BlockStaticLiquid;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.ItemFishFood;
import net.minecraft.item.ItemFishingRod;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.BlockPos;
import java.util.Comparator;
import java.util.List;


import java.util.Comparator;
import java.util.List;

public class EntityAIFishing extends AbstractEntityAIChore {
    private BlockPos targetWater;
    private boolean hasCastRod;
    private int ticks;

    public EntityAIFishing(EntityVillagerMCA entityIn) {
        super(entityIn);
        this.func_75248_a(1);
    }

    public boolean func_75250_a() {
        if (villager.func_110143_aJ() < villager.func_110138_aP()) {
            villager.stopChore();
        }
        return EnumChore.byId(villager.get(EntityVillagerMCA.ACTIVE_CHORE)) == EnumChore.FISH;
    }

    public void func_75246_d() {
        super.func_75246_d();

        if (!villager.inventory.contains(ItemFishingRod.class)) {
            villager.say(getAssigningPlayer(), "chore.fishing.norod");
            villager.stopChore();
            return;
        }

        if (targetWater == null) {
            List<BlockPos> nearbyStaticLiquid = Util.getNearbyBlocks(villager.func_190671_u_(), villager.field_70170_p, BlockStaticLiquid.class, 12, 3);
            targetWater = nearbyStaticLiquid.stream()
                    .filter((p) -> villager.field_70170_p.func_180495_p(p).func_177230_c() == Blocks.field_150355_j)
                    .min(Comparator.comparingDouble(villager::func_174818_b)).orElse(null);
        } else if (villager.func_174818_b(targetWater) > 5.0D) villager.func_70661_as().func_75484_a(villager.func_70661_as().func_179680_a(targetWater), 0.8D);
        else if (villager.func_174818_b(targetWater) < 5.0D) {
            villager.func_70661_as().func_75499_g();

            if (!hasCastRod) {
                villager.func_184609_a(EnumHand.MAIN_HAND);
                hasCastRod = true;
            }

            ticks++;

            if (ticks >= villager.field_70170_p.field_73012_v.nextInt(200) + 200) {
                if (villager.field_70170_p.field_73012_v.nextFloat() >= 0.35F) {
                    int typesSize = ItemFishFood.FishType.values().length;
                    ItemFishFood.FishType type = ItemFishFood.FishType.values()[villager.field_70170_p.field_73012_v.nextInt(typesSize)];
                    ItemStack stack = new ItemStack(Items.field_151115_aP, 1, type.func_150976_a());

                    villager.func_184609_a(EnumHand.MAIN_HAND);
                    villager.inventory.func_174894_a(stack);
                    villager.func_184586_b(EnumHand.MAIN_HAND).func_77972_a(2, villager);
                }
                ticks = 0;
            }
        }
    }
}
