package mca.entity.ai;

import mca.entity.EntityVillagerMCA;
import mca.enums.EnumChore;

public class EntityAIGoHangout extends AbstractEntityAIChore {
    private boolean atHangout = false;
    
    public EntityAIGoHangout(EntityVillagerMCA villagerIn) {
        super(villagerIn);
        this.func_75248_a(1);
    }

    public boolean func_75250_a() {
        if (villager.getHangout().func_177956_o() == 0) {
            return false; //no workplace
        }

        //no time, has to work
        if (EnumChore.byId(villager.get(EntityVillagerMCA.ACTIVE_CHORE)) != EnumChore.NONE) {
            return false;
        }

        long time = villager.field_70170_p.func_72820_D() % 24000L;

        if (time < 9000 || time > 11000) {
            //spare time is over, villager will start going home
            atHangout = false;
            return false;
        }

        double validArea = 64.0D; //allows 8 blocks radius to stay
        double distance = villager.func_174818_b(villager.getHangout());

        if (!atHangout) {
            if (distance < 9.0) {
                //arrived at hangout
                atHangout = true;
            } else {
                //did not reach workplace for today -> shrink valid area so the villager gathers clearly at his workplace
                validArea = 4.0D;
            }
        }

        return distance > validArea;
    }

    public boolean func_75253_b() {
        return !villager.func_70661_as().func_75500_f();
    }

    public void func_75249_e() {
        villager.moveTowardsBlock(villager.getHangout());
    }

    public void func_75246_d() {

    }
}
