package mca.entity.ai;

import mca.core.MCA;
import mca.entity.EntityVillagerMCA;
import mca.enums.EnumChore;
import mca.util.Util;
import net.minecraft.block.BlockCrops;
import net.minecraft.block.properties.IProperty;
import net.minecraft.block.state.IBlockState;
import net.minecraft.item.*;
import net.minecraft.util.EnumHand;
import net.minecraft.util.NonNullList;
import net.minecraft.util.math.BlockPos;
import java.util.ArrayList;
import java.util.List;


import java.util.ArrayList;
import java.util.List;

public class EntityAIHarvesting extends AbstractEntityAIChore {
    private int blockWork = 0;
    private int lastCropScan = 0;

    public EntityAIHarvesting(EntityVillagerMCA villagerIn) {
        super(villagerIn);
        this.func_75248_a(1);
    }

    public boolean func_75250_a() {
        if (villager.func_110143_aJ() < villager.func_110138_aP()) {
            villager.stopChore();
        }
        return EnumChore.byId(villager.get(EntityVillagerMCA.ACTIVE_CHORE)) == EnumChore.HARVEST && (blockWork - villager.field_70173_aa) < 0;
    }

    public boolean func_75253_b() {
        return !villager.func_70661_as().func_75500_f();
    }

    private BlockPos searchCrop(int rangeX, int rangeY) {
        List<BlockPos> nearbyCrops = Util.getNearbyBlocks(villager.func_190671_u_(), villager.field_70170_p, BlockCrops.class, rangeX, rangeY);
        List<BlockPos> harvestable = new ArrayList<>();
        for (BlockPos pos : nearbyCrops) {
            IBlockState state = villager.field_70170_p.func_180495_p(pos);
            BlockCrops crop = (BlockCrops) state.func_177230_c();

            if (crop.func_185525_y(state)) {
                harvestable.add(pos);
            }
        }

        return Util.getNearestPoint(villager.func_190671_u_(), harvestable);
    }

    public void func_75249_e() {
        if (!villager.inventory.contains(ItemHoe.class)) {
            villager.say(getAssigningPlayer(), "chore.harvesting.nohoe");
            villager.stopChore();
        }

        //search crop
        BlockPos target = searchCrop(16, 3);

        //no crop next to villager -> long range scan
        //limited to once a minute to reduce CPU usage
        if (target == null && villager.field_70173_aa - lastCropScan > 1200) {
            //MCA.getLog().info(villager.getName() + " scans for crops");
            lastCropScan = villager.field_70173_aa;
            target = searchCrop(32, 16);
        }

        if (target == null) {
            if (villager.getWorkplace().func_177956_o() > 0 && villager.func_174818_b(villager.getWorkplace()) > 256.0D) {
                //go to their workplace (if set and more than 16 blocks away)
                //MCA.getLog().info(villager.getName() + " goes to workplace");
                villager.moveTowardsBlock(villager.getWorkplace());
            } else {
                //failed (no crop on range), allows now other, lower priority tasks to interrupt
                //MCA.getLog().info(villager.getName() + " idles");
                blockWork = villager.field_70173_aa + 100 + villager.func_70681_au().nextInt(100);
            }
        } else {
            //harvest if next to it, else try to reach it
            double distanceTo = Math.sqrt(villager.func_174818_b(target));
            if (distanceTo >= 2.0D) {
                if (!villager.func_70661_as().func_75484_a(villager.func_70661_as().func_179680_a(target), 0.5D)) {
                    villager.func_184595_k(target.func_177958_n(), target.func_177956_o(), target.func_177952_p());
                }
            } else {
                //harvest
                IBlockState state = villager.field_70170_p.func_180495_p(target);
                if (state.func_177230_c() instanceof BlockCrops) {
                    BlockCrops crop = (BlockCrops) state.func_177230_c();
                    NonNullList<ItemStack> drops = NonNullList.func_191196_a();
                    crop.getDrops(drops, villager.field_70170_p, target, state, 0);
                    for (ItemStack stack : drops) {
                        villager.inventory.func_174894_a(stack);
                    }

                    villager.func_184609_a(EnumHand.MAIN_HAND);
                    villager.func_184586_b(EnumHand.MAIN_HAND).func_77972_a(2, villager);

                    try {
                        IProperty<Integer> property = (IProperty<Integer>) crop.func_176194_O().func_185920_a("age");
                        villager.field_70170_p.func_175656_a(target, state.func_177226_a(property, 0));
                    } catch (Exception e) { // age property may have some issues on certain mods, if it errors just set to air
                        MCA.getLog().warn("Error resetting crop age at " + target.toString() + "! Setting to air.");
                        villager.field_70170_p.func_175698_g(target);
                    }
                }

                //wait before harvesting next crop
                ItemStack hoeStack = villager.inventory.getBestItemOfType(ItemHoe.class);
                float efficiency = hoeStack == ItemStack.field_190927_a ? 0.0f : Item.ToolMaterial.valueOf(((ItemHoe) hoeStack.func_77973_b()).func_77842_f()).func_77998_b();
                blockWork = villager.field_70173_aa + (int) Math.max(2.0f, 60.0f - efficiency * 5.0f);
            }
        }
    }
}
