package mca.entity.ai;

import mca.core.Constants;
import mca.entity.EntityVillagerMCA;
import mca.enums.EnumMoveState;
import net.minecraft.entity.ai.EntityAIBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.pathfinding.PathNavigate;

public class EntityAIMoveState extends EntityAIBase {
    private final EntityVillagerMCA villager;

    public EntityAIMoveState(EntityVillagerMCA entityIn) {
        this.villager = entityIn;
        this.func_75248_a(1);
    }

    public boolean func_75250_a() {
        return !villager.playerToFollowUUID.equals(Constants.ZERO_UUID) || EnumMoveState.byId(villager.get(EntityVillagerMCA.MOVE_STATE)) == EnumMoveState.STAY;
    }

    public void func_75246_d() {
        PathNavigate nav = villager.func_70661_as();
        EntityPlayer playerToFollow = villager.field_70170_p.func_152378_a(villager.playerToFollowUUID);

        switch (EnumMoveState.byId(villager.get(EntityVillagerMCA.MOVE_STATE))) {
            case FOLLOW:
                double distance = playerToFollow != null ? villager.func_70032_d(playerToFollow) : -1.0D;
                if (playerToFollow == null) {
                    villager.set(EntityVillagerMCA.MOVE_STATE, EnumMoveState.MOVE.getId());
                    break;
                } else if (distance >= 3.0D && distance <= 10.0D) {
                    nav.func_75484_a(nav.func_75494_a(playerToFollow), villager.func_184218_aH() ? 1.7D : 0.8D);
                } else if (distance > 10.0D) {
                    villager.func_184595_k(playerToFollow.field_70165_t, playerToFollow.field_70163_u, playerToFollow.field_70161_v);
                } else { // close enough to avoid crowding the player
                    nav.func_75499_g();
                }
                break;
            case STAY:
                nav.func_75499_g();
                break;
        }
    }
}
