package mca.entity.ai;

import lombok.RequiredArgsConstructor;
import mca.core.Constants;
import mca.core.MCA;
import mca.core.minecraft.ItemsMCA;
import mca.entity.EntityVillagerMCA;
import mca.entity.data.PlayerSaveData;
import net.minecraft.entity.ai.EntityAIBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.SoundEvents;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumParticleTypes;
import net.minecraft.util.SoundCategory;

@RequiredArgsConstructor
public class EntityAIProcreate extends EntityAIBase {
    private final EntityVillagerMCA villager;
    public int procreateTimer;

    @Override
    public boolean func_75250_a() {
        return villager.get(EntityVillagerMCA.IS_PROCREATING);
    }

    @Override
    public void func_75246_d() {
        if (procreateTimer % 5 == 0) villager.spawnParticles(EnumParticleTypes.HEART);

        if (--procreateTimer <= 0) {
            villager.set(EntityVillagerMCA.IS_PROCREATING, false);

            EntityPlayer spousePlayer = villager.field_70170_p.func_152378_a(villager.get(EntityVillagerMCA.SPOUSE_UUID).or(Constants.ZERO_UUID));
            if (spousePlayer != null) {
                villager.field_70170_p.func_184148_a(null, villager.field_70165_t, villager.field_70163_u, villager.field_70161_v, SoundEvents.field_187665_Y, SoundCategory.NEUTRAL, 1.0F, 1.0F);
                spousePlayer.field_71071_by.func_70441_a(new ItemStack(villager.func_70681_au().nextBoolean() ? ItemsMCA.BABY_BOY : ItemsMCA.BABY_GIRL));
                PlayerSaveData.get(spousePlayer).setBabyPresent(true);

                if (villager.func_70681_au().nextFloat() < MCA.getConfig().chanceToHaveTwins / 100)
                    spousePlayer.field_71071_by.func_70441_a(new ItemStack(villager.func_70681_au().nextBoolean() ? ItemsMCA.BABY_BOY : ItemsMCA.BABY_GIRL));
            }
        }
    }
}
