package mca.entity.ai;

import mca.entity.EntityVillagerMCA;
import mca.enums.EnumChore;
import mca.util.Util;
import net.minecraft.block.Block;
import net.minecraft.block.BlockOre;
import net.minecraft.item.Item;
import net.minecraft.item.ItemPickaxe;
import net.minecraft.item.ItemStack;
import net.minecraft.util.math.BlockPos;

public class EntityAIProspecting extends AbstractEntityAIChore {
    private int ticks;

    public EntityAIProspecting(EntityVillagerMCA entityIn) {
        super(entityIn);
        this.func_75248_a(4);
    }

    public boolean func_75250_a() {
        if (villager.func_110143_aJ() < villager.func_110138_aP()) {
            villager.stopChore();
        }
        return EnumChore.byId(villager.get(EntityVillagerMCA.ACTIVE_CHORE)) == EnumChore.PROSPECT;
    }

    public void func_75246_d() {
        super.func_75246_d();

        ItemStack pickStack = villager.inventory.getBestItemOfType(ItemPickaxe.class);
        if (pickStack == ItemStack.field_190927_a) {
            villager.say(getAssigningPlayer(), "chore.mining.nopick");
            villager.stopChore();
            return;
        }

        float efficiency = Item.ToolMaterial.valueOf(((ItemPickaxe) pickStack.func_77973_b()).func_77861_e()).func_77998_b();
        float notifyRate = Math.max(600 - efficiency * 50, 100);

        if (ticks >= notifyRate) {
            BlockPos closestOre = Util.getNearestPoint(villager.func_190671_u_(), Util.getNearbyBlocks(villager.func_190671_u_(), villager.field_70170_p, BlockOre.class, 4, 3));

            if (closestOre != null) {
                Block block = villager.field_70170_p.func_180495_p(closestOre).func_177230_c();
                villager.say(getAssigningPlayer(), "chore.mining.orenotify", block.func_149732_F());
                pickStack.func_77972_a(2, villager);
            }
            ticks = 0;
            return;
        }
        ticks++;
    }
}
