package mca.entity.ai;

import mca.core.minecraft.ProfessionsMCA;
import mca.entity.EntityVillagerMCA;
import net.minecraft.util.math.BlockPos;

public class EntityAISleeping extends AbstractEntityAIChore {
    public EntityAISleeping(EntityVillagerMCA villagerIn) {
        super(villagerIn);
        this.func_75248_a(1);
    }

    public boolean func_75250_a() {
        //let the avoid tasks work
        if (villager.func_110143_aJ() < villager.func_110138_aP()) {
            return false;
        }

        long time = villager.field_70170_p.func_72820_D() % 24000L;
        if (villager.get(EntityVillagerMCA.BED_POS) == BlockPos.field_177992_a && time < 16000) { //at tick 18000 villager without bed are allowed to automatically choose one
            //wake up if still sleeping
            if (villager.isSleeping()) {
                villager.stopSleeping();
            }
            return false;
        }

        //if guards detect enemies they won't sleep
        if (villager.getProfessionForge() == ProfessionsMCA.guard && villager.func_70638_az() != null) {
            //wake up, this is a emergency!
            if (villager.isSleeping()) {
                villager.stopSleeping();
            }
            return false;
        }

        if (time > (villager.getProfessionForge() == ProfessionsMCA.guard ? 14000 : 12000) && time < 23000) {
            return true;
        } else {
            //wake up if still sleeping
            if (villager.isSleeping()) {
                villager.stopSleeping();
            }
            return false;
        }
    }

    public boolean func_75253_b() {
        return func_75250_a() && (!villager.func_70661_as().func_75500_f() || villager.isSleeping());
    }

    public void func_75249_e() {
        if (villager.get(EntityVillagerMCA.BED_POS) == BlockPos.field_177992_a || villager.func_174818_b(villager.get(EntityVillagerMCA.BED_POS)) < 4.0) {
            //search for the nearest bed, might be different than before
            BlockPos pos = villager.searchBed();

            if (pos == null) {
                //no bed found, let's forget about the remembered bed
                if (villager.get(EntityVillagerMCA.BED_POS) != BlockPos.field_177992_a) {
                    //TODO: notify the player?
                    villager.set(EntityVillagerMCA.BED_POS, BlockPos.field_177992_a);
                }
            } else {
                villager.set(EntityVillagerMCA.BED_POS, pos);
                villager.startSleeping();
            }
        } else {
            villager.moveTowardsBlock(villager.get(EntityVillagerMCA.BED_POS), 0.75);
        }
    }

    public void func_75251_c() {
        if (villager.isSleeping()) {
            villager.stopSleeping();
        }
    }

    public void func_75246_d() {
        if (villager.isSleeping()) {
            villager.func_70034_d(0.0f);
            villager.field_70177_z = 0.0f;
        }
    }
}
