package mca.entity.data;

import lombok.Getter;
import mca.core.Constants;
import mca.core.MCA;
import mca.enums.EnumMarriageState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.text.TextComponentString;
import net.minecraft.world.World;
import net.minecraft.world.storage.WorldSavedData;
import java.util.Arrays;
import java.util.List;
import java.util.UUID;
import java.util.stream.Collectors;


import java.lang.reflect.Field;
import java.lang.reflect.Modifier;
import java.util.Arrays;
import java.util.List;
import java.util.UUID;
import java.util.stream.Collectors;

@Getter
public class PlayerSaveData extends WorldSavedData {
    private static final String PREFIX = "MCA-Player-V1-";

    private UUID spouseUUID = Constants.ZERO_UUID;
    private EnumMarriageState marriageState = EnumMarriageState.NOT_MARRIED;
    private String spouseName = "";
    private boolean babyPresent = false;

    public PlayerSaveData(String id) {
        super(id);
    }

    public static PlayerSaveData get(EntityPlayer player) {
        String dataId = PREFIX + player.func_110124_au().toString();
        PlayerSaveData data = (PlayerSaveData) player.field_70170_p.func_72943_a(PlayerSaveData.class, dataId);

        if (data == null) {
            data = new PlayerSaveData(dataId);
            player.field_70170_p.func_72823_a(dataId, data);
        }

        return data;
    }

    public static PlayerSaveData getExisting(World world, UUID uuid) {
        return (PlayerSaveData) world.func_72943_a(PlayerSaveData.class, PREFIX + uuid.toString());
    }

    @Override
    public NBTTagCompound func_189551_b(NBTTagCompound nbt) {
        nbt.func_186854_a("spouseUUID", spouseUUID);
        nbt.func_74768_a("marriageState", marriageState.getId());
        nbt.func_74778_a("spouseName", spouseName);
        nbt.func_74757_a("babyPresent", babyPresent);
        return nbt;
    }

    @Override
    public void func_76184_a(NBTTagCompound nbt) {
        spouseUUID = nbt.func_186857_a("spouseUUID");
        marriageState = EnumMarriageState.byId(nbt.func_74762_e("marriageState"));
        spouseName = nbt.func_74779_i("spouseName");
        babyPresent = nbt.func_74767_n("babyPresent");
    }

    public boolean isMarriedOrEngaged() {
        return marriageState != EnumMarriageState.NOT_MARRIED;
    }

    public void marry(UUID uuid, String name) {
        spouseUUID = uuid;
        marriageState = EnumMarriageState.MARRIED;
        spouseName = name;
        func_76185_a();
    }

    public void endMarriage() {
        spouseUUID = Constants.ZERO_UUID;
        spouseName = "";
        marriageState = EnumMarriageState.NOT_MARRIED;
        func_76185_a();
    }

    public void setBabyPresent(boolean value) {
        this.babyPresent = value;
        func_76185_a();
    }

    public void reset() {
        endMarriage();
        setBabyPresent(false);
        func_76185_a();
    }

    public List<Field> getDataFields() {
        return Arrays.stream(this.getClass().getDeclaredFields()).filter(f -> !Modifier.isFinal(f.getModifiers())).collect(Collectors.toList());
    }

    public void dump(EntityPlayer player) {
        for (Field f : getDataFields()) {
            try {
                player.func_145747_a(new TextComponentString(f.getName() + " = " + f.get(this).toString()));
            } catch (Exception e) {
                MCA.getLog().error("Error dumping player data!");
                MCA.getLog().error(e);
            }
        }
    }
}
