package mca.entity.data;

import mca.entity.EntityVillagerMCA;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.world.World;
import net.minecraft.world.storage.WorldSavedData;
import java.util.HashMap;
import java.util.Map;
import java.util.UUID;


import java.util.HashMap;
import java.util.Map;
import java.util.UUID;

/**
 * SavedVillagers handles saving dead villagers to the world which allows them to be restored later.
 */
public class SavedVillagers extends WorldSavedData {
    private static final String DATA_ID = "MCA-Villagers-V1";
    private Map<String, NBTTagCompound> villagerData = new HashMap<>();

    public SavedVillagers(String id) {
        super(id);
    }

    public static SavedVillagers get(World world) {
        SavedVillagers data = (SavedVillagers) world.func_72943_a(SavedVillagers.class, DATA_ID);
        if (data == null) {
            data = new SavedVillagers(DATA_ID);
            world.func_72823_a(DATA_ID, data);
        }
        return data;
    }

    public void save(EntityVillagerMCA villager) {
        villagerData.put(villager.func_110124_au().toString(), villager.func_189511_e(new NBTTagCompound()));
        func_76185_a();
    }

    public void remove(UUID uuid) {
        villagerData.remove(uuid.toString());
        func_76185_a();
    }

    public Map<String, NBTTagCompound> getMap() {
        return villagerData;
    }

    public NBTTagCompound loadByUUID(UUID uuid) {
        return villagerData.get(uuid.toString());
    }

    @Override
    public NBTTagCompound func_189551_b(NBTTagCompound nbt) {
        villagerData.forEach(nbt::func_74782_a);
        return nbt;
    }

    @Override
    public void func_76184_a(NBTTagCompound nbt) {
        nbt.func_150296_c().forEach((k) -> villagerData.put(k, nbt.func_74775_l(k)));
    }
}
