package mca.items;

import mca.core.Constants;
import mca.core.MCA;
import mca.core.minecraft.ItemsMCA;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;
import net.minecraft.item.ItemWrittenBook;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTTagList;
import net.minecraft.nbt.NBTTagString;
import net.minecraft.network.play.server.SPacketSetSlot;
import net.minecraft.util.ActionResult;
import net.minecraft.util.EnumActionResult;
import net.minecraft.util.EnumHand;
import net.minecraft.util.text.ITextComponent;
import net.minecraft.util.text.TextComponentString;
import net.minecraft.util.text.TextComponentUtils;
import net.minecraft.world.World;

public class ItemGuideBook extends ItemWrittenBook {

    public ItemGuideBook() {
        super();
    }

    @Override
    public void func_77663_a(ItemStack itemStack, World world, Entity entity, int unknownInt, boolean unknownBoolean) {
        super.func_77663_a(itemStack, world, entity, unknownInt, unknownBoolean);

        if (!world.field_72995_K && !itemStack.func_77942_o()) ItemsMCA.setBookNBT(itemStack);
    }

    @Override
    public ActionResult<ItemStack> func_77659_a(World worldIn, EntityPlayer playerIn, EnumHand handIn) {
        ItemStack itemstack = playerIn.func_184586_b(handIn);
        if (worldIn.field_72995_K) {
            playerIn.openGui(MCA.getInstance(), Constants.GUI_ID_GUIDEBOOK, worldIn, (int)playerIn.field_70165_t, (int)playerIn.field_70163_u, (int)playerIn.field_70161_v);
        }
        return new ActionResult(EnumActionResult.SUCCESS, itemstack);
    }

    private void resolveContents(ItemStack stack, EntityPlayer player) {
        if (stack.func_77978_p() != null) {
            NBTTagCompound nbttagcompound = stack.func_77978_p();

            if (!nbttagcompound.func_74767_n("resolved")) {
                nbttagcompound.func_74757_a("resolved", true);

                if (func_77828_a(nbttagcompound)) {
                    NBTTagList nbttaglist = nbttagcompound.func_150295_c("pages", 8);

                    for (int i = 0; i < nbttaglist.func_74745_c(); ++i) {
                        String s = nbttaglist.func_150307_f(i);
                        ITextComponent itextcomponent;

                        try {
                            itextcomponent = ITextComponent.Serializer.func_186877_b(s);
                            itextcomponent = TextComponentUtils.func_179985_a(player, itextcomponent, player);
                        } catch (Exception var9) {
                            itextcomponent = new TextComponentString(s);
                        }
                        nbttaglist.func_150304_a(i, new NBTTagString(ITextComponent.Serializer.func_150696_a(itextcomponent)));
                    }
                    nbttagcompound.func_74782_a("pages", nbttaglist);

                    if (player instanceof EntityPlayerMP && player.func_184614_ca() == stack) {
                        Slot slot = player.field_71070_bA.func_75147_a(player.field_71071_by, player.field_71071_by.field_70461_c);
                        ((EntityPlayerMP)player).field_71135_a.func_147359_a(new SPacketSetSlot(0, slot.field_75222_d, stack));
                    }
                }
            }
        }
    }
}
